import { ActiveHashRecord, ActiveHashRecordFilter, EagerQueryable, Queryable } from "activehashie";
import { ActiveHashValidation } from "./active_hash_validation";
import { ModelValidationErrorReports } from "./model_validation_error_report";
import { ValidatesMethods } from "./validates_method";
export interface ValidationMethodsCondition<Record extends ActiveHashRecord> {
    if?: ActiveHashRecordFilter<Record>;
    unless?: ActiveHashRecordFilter<Record>;
}
export declare class ValidationMethods<Record extends ActiveHashRecord> {
    private model;
    private validation;
    private errors;
    constructor(model: Queryable<Record>, validation: ActiveHashValidation);
    validates<ValidatesMethod extends keyof ValidatesMethods>(column: keyof Record, method: ValidatesMethod, params: ValidatesMethods[ValidatesMethod], condition?: ValidationMethodsCondition<Record>): void;
    validate(validator: (errors: ModelValidationErrorReports<Record>, model: EagerQueryable<Record>) => void, condition?: ValidationMethodsCondition<Record>): void;
    private filterModelByCondition(condition);
}
